FDC_82077_9__Install:
 push eax
 push ebx




 ;Take the current address right after the kernel
 ;binary in memory, and create a cache for 9 sectors
 ;of the 1.44 MB floppy's FAT12:
 ;;
  mov eax,[_KERN_END]
  mov dword[FAT12_FAT_Start],eax


 ;Add the desired size of the IDT:
 ;;
  add eax,[FAT12_FAT_Size]

 ;Take the opportunity to advance the
 ;kernel end mark:
 ;;
  mov [_KERN_END],eax


 ;;;;;;;;;;;;;;;;;


 ;Take the current address right after the kernel
 ;binary in memory, and create a cache for 9 sectors
 ;of the 1.44 MB floppy's FAT12:
 ;;
  mov eax,[_KERN_END]
  mov dword[Floppy_Sector_Cache_Start],eax


 ;Add the desired size of the IDT:
 ;;
  add eax,[Floppy_Sector_Cache_Size]

 ;Take the opportunity to advance the
 ;kernel end mark:
 ;;
  mov [_KERN_END],eax











 ;Install the ISR in the IDT:
 ;;
  ;      AL == Interrupt Number
  ;     EBX == Entry point of our ISR
  ;;
   mov al,0xF6
   mov ebx,FDC_82077_9_ISR
   call IDT_x86_32__InstallISR






 ;Enable IRQs for the Floppy Controller (IRQ6)
 ;;
  in al,0x21
  and al,10111111b
  out 0x21,al


 pop ebx
 pop eax
ret
