KBC_PS2_8042__Configure_and_Install_Keyboard:
 push eax
 push ebx


 ;AL == Command
 ;AH == Parameter
 ;;
  mov al,0xD1
  mov ah,0xFF   ;Enable A20 and Keyb/Mouse
   call KBC_PS2_8042__send_2partCmd_withNoResults




 ;AL == Command
 ;AH == Parameter
 ;;
  mov al,0x60
;  mov ah,00101101b  ;Enable keyboard with no translation
  mov ah,00001111b  ;Enable mouse and keyboard with no translation
   call KBC_PS2_8042__send_2partCmd_withNoResults



 ;Now Install the ISR in the IDT:
 ;;
  ;      AL == Interrupt Number
  ;     EBX == Entry point of our ISR
  ;;
   mov al,0xF1
   mov ebx,KBC_PS2_8042_Keyboard__ISR
   call IDT_x86_32__InstallISR





  ;Turn on Num Lock and turn off all
  ;other LEDs.
  ;WARNING: Use functions capable to time out
  ;         here in case there is no keyboard
  ;         attached.
  ;;
         call kbc_waitUntilCommandable
         mov al,0xED
         out 0x60,al

         call kbc_waitForDataForUs
         in al,0x60

         call kbc_waitUntilCommandable
         mov al,010b


         out 0x60,al

         call kbc_waitForDataForUs
         in al,0x60











 ;Finally, activate the IRQ by unmasking
 ;its corresponding bit (in the Master PIC:
 ;Bit 1 for IRQ 1, which is the Keyboard):
 ;;
   ;Read the bit mask:
   ;;
    in al,0x21

   ;Unmask bit 1:
   ;;
    and al,11111101b

   ;Send the new bit mask:
   ;;
    out 0x21,al




 pop ebx
 pop eax
ret
