;ECX == Current scan code position in the scan code table
;;
k_leds:
 pusha


  ;Create a variable in the stack (ledstatuschange).
  ;This also updates this variable to avoid sending
  ;commands to the keyboard unnecessarily if the real
  ;configuration of the LEDs has not changed:
  ;;
   push dword [kernel_keyboard_LED_bits]



  ;Interchange the on/off state every time that we stop
  ;pressing the corresponding key:
  ;;
;   mov esi,Keyboard_KeyStates
;   cmp byte[esi+74],0     ;Caps Lock Break
     cmp ecx,74+KSCANSET_2_KNOWN_KEYS
   jne .testNUMBREAK

    not byte[capslock_kernel_status]


   jmp .LEDBREAKS_END
   .testNUMBREAK:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   cmp byte[esi+75],0     ;Num Lock Break
     cmp ecx,75+KSCANSET_2_KNOWN_KEYS
   jne .testSCROLLBREAK

    not byte[numlock_kernel_status]


   jmp .LEDBREAKS_END
   .testSCROLLBREAK:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   cmp byte[esi+76],0     ;Scroll Lock Break
     cmp ecx,76+KSCANSET_2_KNOWN_KEYS
   jne .LEDBREAKS_END


    not byte[scrolllock_kernel_status]


   .LEDBREAKS_END:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   cmp byte[esi+74],1     ;Caps Lock Make
     cmp ecx,74
   jne .testNUMMAKE

     cmp byte[capslock_kernel_status],0
     je .nochangecaps

       or byte[kernel_keyboard_LED_bits],4
       jmp .changecaps_END

     .nochangecaps:

       and byte[kernel_keyboard_LED_bits],011b


     .changecaps_END:



   jmp .LEDMAKES_END
   .testNUMMAKE:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   cmp byte[esi+75],1     ;Num Lock Make
     cmp ecx,75
   jne .testSCROLLMAKE




     cmp byte[numlock_kernel_status],0
     je .nochangenum

       or byte[kernel_keyboard_LED_bits],2
       jmp .changenum_END

     .nochangenum:

       and byte[kernel_keyboard_LED_bits],101b


     .changenum_END:





   jmp .LEDMAKES_END
   .testSCROLLMAKE:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   cmp byte[esi+76],1     ;Scroll Lock Make
     cmp ecx,76
   jne .LEDMAKES_END



     cmp byte[scrolllock_kernel_status],0
     je .nochangescroll

       or byte[kernel_keyboard_LED_bits],1
       jmp .changescroll_END

     .nochangescroll:

       and byte[kernel_keyboard_LED_bits],110b


     .changescroll_END:

   .LEDMAKES_END:


 ;if(ledstatuschange!=kernel_keyboard_LED_bits)
 ;;
  mov al,[kernel_keyboard_LED_bits]
  cmp byte[esp],al
  je .noupdateLEDs

         call kbc_waitUntilCommandable
         mov al,0xED
         out 0x60,al

         call kbc_waitForDataForUs
         in al,0x60

         call kbc_waitUntilCommandable
         mov al,[kernel_keyboard_LED_bits]


         out 0x60,al

         call kbc_waitForDataForUs
         in al,0x60


  .noupdateLEDs:


  ;Clean up our stack variables (only 1):
  ;;
   add esp,4

 popa
ret
