;This function takes a cluster
;number, and converts it into
;its raw LBA address, which is
;always into the data area.
;
;
;EBX = cluster number
;;
FAT12_cluster2lba:

 ;If we substract 2 to
 ;the cluster number, and then
 ;add the number of reserved
 ;sectors (1 for the MBR), the
 ;size of each FAT in sectors
 ;(18) and the number of root
 ;directory sectors (14), and
 ;seeing how clusters always start
 ;from 2, for a mathematical matter,
 ;then we end up with 31, for a
 ;minimum sum of 33, which is of course
 ;the first LBA sector in the floppy's
 ;data area:
 ;;
  add ebx,31


ret
