;//Takes in AL 1 value between 0 & 255 (0-FF)
;//and puts the "hex" as an "ASCII hex" in AX:
;;;
bin2hex:
pushf
  ;//Take a copy of our value into AH
  ;//to have it in AL and also in AH
  ;;;
    mov ah,al


  and al,00001111b;Take the lower 4 bits
  cmp al,0x09
  ja .noner1     ;See if this value is higher than 9
   add al,0x30   ;if(AL>=0 && AL<=9) add 0x30 (char '0') to convert to ASCII
   jmp .noner1_1  ;Go to the next step

  .noner1:
   add al,0x37   ;if(AL>9) add 0x37 (char 'A') to convert to ASCII 'A'--'F'

  .noner1_1:



  ;//Now it's the time to use our
  ;//backup value in AH (convenient
  ;//to avoid using the stack, etc...)
  ;;;
    shr ah,4           ;Now, take the higher 4 bits
    cmp ah,0x09
    ja .noner2         ;See if this value is higher than 9
     add ah,0x30       ;if(AH>=0 && AH<=9) add 0x30 (char '0') to convert to ASCII
     jmp .noner2_2     ;Go to the next step

    .noner2:
     add ah,0x37  ;if(AH>9) add 0x37 (char 'A') to convert to ASCII 'A'--'F'

    .noner2_2:


  ;AH == higher hex ASCII digit value
  ;AL == lower hex ASCII digit value
  ;;

popf
ret
