clrscr:
 push eax
 push ebx
 push ecx
 push edi

  xor ebx,ebx
   call VGAVideo_CRTC_setTextCurPos


  mov edi,0xB8000
  mov dword[console_ptr],edi
  mov ecx,4000/4
  mov eax,0x07200720
   rep stosd



 pop edi
 pop ecx
 pop ebx
 pop eax
ret


























console_doCRLFeffect:
 push eax
 push ebx
 push edx

  ;Take the current offset of the
  ;on-screen buffer to see if we
  ;are over the limit in which we
  ;should perform a (software) scrolling
  ;of the screen:
  ;;
   mov edx,[console_ptr]
   mov eax,edx    ;This is VITAL for the division
                  ;and we have removed it...
   add edx,160            ;We add this because if we
                          ;are at the last line and
                          ;do the CRLF effect for newline,
                          ;this sum will produce a value
                          ;that corresponds to an address
                          ;beyond the visible screen, and
                          ;that requires scrolling the
                          ;whole text screen.
    call console_scroll_update




  ;Remove the frame buffer base address from it
  ;to convert it into a simple offset:
  ;;
   sub eax,0xB8000

  ;Divide by 2, because our hardware cursor
  ;considers all screen positions as one-byte
  ;positions:
  ;;
   shr eax,1


  ;Prepare high DWORD for a 32-bit division:
  ;;
   xor edx,edx

  ;Divisor must be 80:
  ;;
   mov ebx,80


  ;Divide the screen offset by 80, to get the
  ;Y offset it represents:
  ;;
   div ebx    ;EDX:EAX/EBX  == EDX remainder, EAX quotient


  ;Prepare high DWORD for a 32-bit multiplication:
  ;;
   xor edx,edx


  ;Multiply our quotient by 80, to get a value that
  ;is aligned to 80. It represents X=0, and the
  ;correct value of Y:
  ;;
   mul ebx    ;EAX*EBX == EDX:EAX result

  
  ;Save the 32-bit multiplication in EAX:
  ;;
   mov ebx,eax

  ;See if we are in the last line. If so,
  ;avoid placing the cursor beyond that line:
  ;;
   cmp ebx,2000-80
   jae .nomoveCur

    ;But if we are in lines 0-78, advance one
    ;more line:
    ;;
     add ebx,80

  .nomoveCur:


  ;Re-position the hardware cursor based on
  ;all of the previous multiplications and divisions:
  ;;
   call VGAVideo_CRTC_setTextCurPos


  ;Now multiply this cursor position value by 2,
  ;to convert it to an actual 2-byte on-screen offset:
  ;;
   shl ebx,1

  ;Add the frame buffer base address so it turns into
  ;a valid memory offset:
  ;;
   add ebx,0xB8000

  ;Update the console pointer, pointing to the start of
  ;a new line:
  ;;
   mov [console_ptr],ebx



 pop edx
 pop ebx
 pop eax
ret

