;Inputs:
;     ESI == Pointer to string
;     ECX == Maximum number of bytes to search
;      AL == Nearest occurrence of this byte value to search
;
;Outputs:
;     ESI == Value of nearest occurrence, if found.
;            If not found, ESI is simply left unchanged.
;;
 KernString_find_nearest_byte:
  push ecx
  push edx



  ;Create a stack DWORD variable:
  ;;
   push esi

  .l:

    ;Take our current pointer variable value:
    ;;
     mov edx,[esp]



   ;See if the current character matches
   ;with the one we are looking for.
   ;
   ;If so, put the new offset value in ESI
   ;and break the loop to finish:
   ;;
    cmp byte[edx],al
    jne .noMatch

       mov esi,[esp]
       jmp .l_END

    .noMatch:



   ;Go to the next character:
   ;;
    inc dword[esp]


  dec ecx   ;Discount one more of the maximum characters
  jnz .l
  .l_END:


  ;Free up the space of the stack variable:
  ;;
   add esp,4



  pop edx
  pop ecx
 ret
