;Inputs:
;      BX == Byte cursor offset (0 to 65535).
;            Actually, these VGA registers don't take
;            into account the hidden attribute bytes, so
;            for them, a screen of 80x25 just has cursor
;            offsets that range from 0 to 65535.
;;
 VGAVideo_CRTC_setTextCurPos:
  push eax
  push ebx
  push edx


   ;See if the specified cursor position
   ;is above the visible screen. If so,
   ;place the cursor in the very last
   ;visible position:
   ;;
    cmp bx,1999
    jbe .ok

     mov bx,1999


    .ok:


       mov al,14      ;reg 14 (MSB)
       mov ah,bh      ;MSB value
       mov dx,03D4h   ;index reg
       out dx,ax      ;specify r/w to CRTC port 14

       mov al,15      ;reg 15 (LSB)
       mov ah,bl      ;LSB value
       mov dx,03D4h   ;index reg
       out dx,ax      ;specify r/w to CRTC port 15


  pop edx
  pop ebx
  pop eax
 ret
