KB_ASCII_Print_Table:

;Scan code positions 0-35 in our scan code table:
;;
 db "abcdefghijklmnopqrstuvwxyz1234567890"

;Scan code positions 36-47:
;;
 db "`-=\[];',./ "

;Scan code positions 48-62 (printable keypad keys,
;all keypad keys except Num Lock and ENTER):
;;
 db "/*-+.0123456789"

;Extra printable keys (63):
;;
 db "\"







;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;






KB_ASCII_Shift_Print_Table:

;Scan code positions 0-35 in our scan code table:
;;
 db "ABCDEFGHIJKLMNOPQRSTUVWXYZ!@#$%^&*()"

;Scan code positions 36-47:
;;
 db '~_+|{}:"<>? '

;Scan code positions 48-62 (printable keypad keys,
;all keypad keys except Num Lock and ENTER).
;
;Note that when pressing Shift, these symbolic keys
;don't change, but that . becomes "Del",
;0 becomes "Ins", 3 becomes "PgDown", 9 becomes "PgUp",
;2, 4, 6 and 8 become arrows down, left, right and Up,
;respectively, 1 becomes End and 7 becomes Home
;and 5 apparently becomes nonthing by default.
;So at the point where we can handle Shift properly
;we should meet those actions.
;
;Also, when using Alt, no keypad keys seem to respond,
;except for the numeric ones, and according to Windows/DOS
;behavior, those Alt+KeypadNumbers combination should
;produce their corresponding ASCII codes (except for 0, but
;since our kernel has such low level, we should probably allow
;it, specially for the time we could be able to write binary
;code directly using those key combinations, etc.).
;;
 db "/*-+.0123456789"

;Extra printable keys (63):
;;
 db "|"

