PIT_8253_4__Install:
 push eax
 push ebx


 ;Set our PIT timer to 1 ms:
 ;;
  call PIT_8253_4__set_1ms



 ;Now Install the ISR in the IDT:
 ;;
  ;      AL == Interrupt Number
  ;     EBX == Entry point of our ISR
  ;;
   mov al,0xF0
   mov ebx,PIT_8253_4__ISR
   call IDT_x86_32__InstallISR



 ;Finally, activate the IRQ by unmasking
 ;its corresponding bit (in the Master PIC:
 ;Bit 0 for IRQ 0, which is the PIT):
 ;;
   ;Read the bit mask:
   ;;
    in al,0x21

   ;Unmask bit 0:
   ;;
    and al,11111110b

   ;Send the new bit mask:
   ;;
    out 0x21,al



 pop ebx
 pop eax
ret
