;EBX = LBA sector
;
FDC_readSector_LBAFloppyA_1_44:
 pusha


;call FDC_TurnOnFloppyA_1_44
;call FDC_RecalibrateFloppyA_1_44
 call FDC_SeekTrackFloppyA_1_44
 call FDC_SetupDMAFloppyA_1_44_SingleSectorRead
 call FDC_SendReadSectorCommandFloppyA_1_44
;call FDC_TurnOffFloppyA_1_44


 popa
ret


















































;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



FDC_TurnOnFloppyA_1_44:
 push ecx

   ;1. turn disk motor on and set delay time for drive spin up
   ;1. turn disk motor on and set delay time for drive spin up
   ;1. turn disk motor on and set delay time for drive spin up
     ;Encendemos el motor de la disquetera:
       xor ecx,ecx
       mov cl,(FD_selectA|FD_enable|FD_DMA_IO_enable|FD_motoronA)
       mov ch,0
         call FD_executeFloppyDOR

 pop ecx
ret







FDC_RecalibrateFloppyA_1_44:
 push ecx

       mov cl,FD_selectA
        call FD_recalibrate
       mov cl,FD_selectA
        call FD_recalibrate
       mov cl,FD_selectA
        call FD_recalibrate
       mov cl,FD_selectA
        call FD_recalibrate
       mov cl,FD_selectA
        call FD_recalibrate
       mov cl,FD_selectA
        call FD_recalibrate

 pop ecx
ret





;EBX = LBA sector
;
FDC_SeekTrackFloppyA_1_44:
 push eax
 push ebx
 push ecx

 ;Multiply by 4:
 ;;
  shl ebx,2

 ;Add the base address of LBA table:
 ;;
  add ebx,Floppy_FAT12_LBA_Table



       mov al,[ebx+1]    ;get head
       shl al,2
       mov cl,(FD_selectA|FD_selectHead0)
       or cl,al          ;set correct head in CL
       mov ch,[ebx]      ;set to cylinder X
       call FD_floppySeek


 pop ecx
 pop ebx
 pop eax
ret















;EBX = LBA sector
;
FDC_SendReadSectorCommandFloppyA_1_44:
 pusha

 ;Multiply by 4:
 ;;
  shl ebx,2

 ;Add the base address of LBA table:
 ;;
  add ebx,Floppy_FAT12_LBA_Table



      mov al,01000110b
      call FD_out       ;0byte

      mov cl,[ebx+1]    ;get head
      shl cl,2
      mov al,(FD_selectA|FD_selectHead0)
      or al,cl          ;set correct head in CL
      call FD_out       ;1byte

      mov al,[ebx]      ;0       ;2byte
      call FD_out  ;cyl num

      mov al,[ebx+1]
      call FD_out  ;head num

      mov al,[ebx+2] ;1    ;2
      call FD_out  ;sect num

      mov al,2    ;128*2*x ///// x=2
      call FD_out  ;bytes per sect

      mov al,12h
      call FD_out  ;end of trck

      mov al,27
      call FD_out  ;gap 3 len

      mov al,0xFF
      call FD_out  ;data len

        call FD_waitINT



   ;5. read status information
   ;5. read status information
   ;5. read status information
      call FD_in
      call FD_in
      call FD_in
      call FD_in
      call FD_in
      call FD_in
      call FD_in

 popa
ret







FDC_TurnOffFloppyA_1_44:
 push ecx

     mov cl,(FD_selectA|FD_enable|FD_motoroffA)    ;add for normal
       call FD_executeFloppyDOR                    ;add for normal

 pop ecx
ret
