;Inputs:
;       ESI == argument string
;
;Outputs:
;       EAX == machine binary value of
;              the binary, decimal or hexadecimal
;              string
;;
sys_arg2num:
  push ebx
  push ecx
  push esi




 ;//Take the address of the last character
 ;//of this argument:
   call mem__ASCIIZ_length
   dec eax
   add eax,esi


  cmp byte[eax],'b'
  jne .trydec

   ;///*$EAX */str2num(/*$BL numbase, $ESI strbuff*/)
     mov bl,2
     mov byte[eax],0  ;Replace the base indicator with
                      ;a null byte to avoid interpteting
                      ;it
     call str2num
;     mov byte[eax],'b'  ;Restore the previous byte
  jmp .tryend



  .trydec:
  cmp byte[eax],'0'
  jb .tryhex
  cmp byte[eax],'9'
  ja .tryhex

     mov bl,10
     mov byte[eax+1],0
     call str2num
  jmp .tryend


  .tryhex:
  cmp byte[eax],'h'
  jne .tryend

     mov bl,16
     mov byte[eax],0
     call str2num
;     mov byte[eax],'h'
  .tryend:


  pop esi
  pop ecx
  pop ebx
ret
