;/*
; Inputs:
;        BL  -- base to convert to
;        EAX -- binary value to convert to string
;        EDI -- end of intended string (since the string
;               is generated backwards)
;
; Outputs:
;        ECX -- lenght of string
;        EDI -- start of the generated string
;
;*/
num2str:
 push eax
 push ebx
 push edx
 push ebp


 and ebx,11111111b;
 xor ecx,ecx;



 cmp eax,0
 jnz .noeax0;
   inc ecx;
   mov byte[edi],'0';
   jmp .end;
 .noeax0:


 .while_ln_534543:
 cmp eax,0
 jz .while_ln_534543_end

  inc ecx;
  

  ;//Clear EDX for the 32-bit-only division
  ;//and perform the assembly division:
  ;;
   xor edx,edx;
       div ebx;   ;//EDX:EAX / EBX == EAX quotient
                  ;//                 EDX remainder


  ;//Take a copy of the remainder:
  ;;
   mov ebp,edx;


  ;//Convert binary remainder to ASCII value:
  ;;
   cmp dl,0
   jb .try10
   cmp dl,9
   ja .try10;
    add dl,0x30;  ;// '0' to '9'
   jmp .endif


   .try10:
   cmp dl,10
   jb .endif
    add dl,(0x41-10);  ;// 'A' and beyond


   .endif:


  ;//Put the character in the string:
  ;;
   mov byte[edi],dl;





  dec edi;


 jmp .while_ln_534543;
 .while_ln_534543_end:



  inc edi;





 .end:
 pop ebp
 pop edx
 pop ebx
 pop eax
ret
